/**
 * EasyBeans
 * Copyright (C) 2011 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: EntityBeanClient.java 5898 2011-06-07 12:00:39Z benoitf $
 * --------------------------------------------------------------------------
 */
package org.ow2.easybeans.osgi.itests.applications.ipojoclient;

import java.util.Random;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.io.File;
import java.io.IOException;


import org.ow2.easybeans.examples.entitybean.Employee;
import org.ow2.easybeans.examples.entitybean.SessionFacadeRemote;

/**
 * @author Guillaume Lamirand
 */
public class EntityBeanClient {

   private String outputDirectory = null;

   private SessionFacadeRemote sessionFacadeRemote;


   public void setSessionFacade(SessionFacadeRemote sessionFacadeRemote) {
        this.sessionFacadeRemote = sessionFacadeRemote;
   }

   public void starting() throws IOException {
      System.out.println("EntityBeanClient.starting()");
      this.outputDirectory = System.getProperty("output.directory");
      addEmployee();
   }

   private void addEmployee() throws IOException {
      File jFile = new File(outputDirectory + File.separator  + "addIPOJOEmployee.txt");
      PrintWriter writer = new PrintWriter(new FileWriter(jFile, false), true);
     try {
      int id = new Random().nextInt();
      this.sessionFacadeRemote.addEmployee(id, "Guillaume_" + id);
      Employee employee = this.sessionFacadeRemote.findEmployee(id);
      System.out.println(employee.getName());
      writer.write("OK\n");
      } catch (RuntimeException e) {
        writer.write("KO\n");
        e.printStackTrace();
        e.printStackTrace(writer);
      } catch (Exception e) {
        e.printStackTrace();
        writer.write("KO\n");
        e.printStackTrace(writer);
      } catch (Error e) {
        e.printStackTrace();
        writer.write("KO\n");
        e.printStackTrace(writer);
      } finally {
        writer.close();
      }

   }

   public void stopping() {
      System.out.println("EntityBeanClient.stopping()");
   }

}
